/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Offline教材 オフラインログのcmiタグデータ保持クラス
//			変更履歴
//				2004.01.08	新規作成	二條　智文
//
package jp.co.ntt.lms.lo.Offline.OfflineLog;

import org.w3c.dom.*;
import java.util.*;

/**
 * Offline教材 オフラインログのcmiタグデータ保持クラス<BR>
 * オフラインログの<cmi>ノードを受け取り、自身の内部変数にデータを
 * 格納します。
 */
public class OfflineCmi implements OfflineLogConst {

	// 自身のノードオブジェクトを保持します。
	private Element mobjCmiElm = null;

	// エラーメッセージ
	private static final String ERR_PRE = "<loms>-<lom>-<cmi>:";
	private static final String ERR_NOT_CMI = ERR_PRE + "cmiタグではありません。";

	// 属性保持
	// <cmi>-<core>-<lesson_location>の値を保持します。
	private String mstrLessonLocation;
	// <cmi>-<core>-<lesson_status>の値を保持します。
	private String mstrLessonStatus;
	// <cmi>-<core>-<score>-<raw>の値を保持します。
	private String mstrRaw;
	// <cmi>-<core>-<score>-<max>の値を保持します。
	private String mstrMax;
	// <cmi>-<core>-<score>-<min>の値を保持します。
	private String mstrMin;
	// <cmi>-<core>-<exit>の値を保持します。
	private String mstrExit;
	// <cmi>-<comments>の値を保持します。
	private String mstrComments;

	// <cmi>-<objectives>エレメントデータを保持します。
	private OfflineCmiObjectives mobjObjectives;

	/**
	 * コンストラクタです。
	 * @param objNode cmiエレメントオブジェクト
	 * @exception OfflineLogParseException パースエラー
	 */
	OfflineCmi( Element objElement )
		throws OfflineLogParseException
	{
		// タグ名のチェック(course以外はエラーとする)
		String strTagName = objElement.getTagName();
		if( strTagName == null || !strTagName.equals( LOM_CMI_ELM ) ) {
			throw new OfflineLogParseException( ERR_NOT_CMI );
		}

		mobjCmiElm = objElement;

		parse();

	}

	/**
	 * <cmi>-<core>-<lesson_location>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <cmi>-<core>-<lesson_location>の値
	 */
	public String getLessonLocation() {
		return mstrLessonLocation;
	}

	/**
	 * <cmi>-<core>-<lesson_status>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <cmi>-<core>-<lesson_status>の値
	 */
	public String getLessonStatus() {
		return mstrLessonStatus;
	}

	/**
	 * <cmi>-<core>-<score>-<raw>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String <cmi>-<core>-<score>-<raw>の値
	 */
	public String getRaw() {
		return mstrRaw;
	}

	/**
	 * <cmi>-<core>-<score>-<max>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String <cmi>-<core>-<score>-<max>の値
	 */
	public String getMax() {
		return mstrMax;
	}

	/**
	 * <cmi>-<core>-<score>-<min>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String <cmi>-<core>-<score>-<min>の値
	 */
	public String getMin() {
		return mstrMin;
	}

	/**
	 * <cmi>-<core>-<exit>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String <cmi>-<core>-<exit>の値
	 */
	public String getExit() {
		return mstrExit;
	}

	/**
	 * <cmi>-<comments>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String <cmi>-<comments>の値
	 */
	public String getComments() {
		return mstrComments;
	}

	/**
	 * 指定されたインデックスの<cmi>-<objectives>エレメントデータを取得します。
	 * @return OfflineCmiObjectives
	 */
	public OfflineCmiObjectives getObjectives() {
		return mobjObjectives;
	}



//------------------------------------ 内部関数 --------------------------------
	/**
	 * コンストラクタで受け取ったエレメントないのデータを
	 * 取得して、自身の変数に格納します。
	 */
	private void parse()
		throws OfflineLogParseException
	{
		NodeList objNodeList = null;
		Element objElm = null;

		// <cmi>-<core>-<lesson_location>の値を取得する
		mstrLessonLocation = OfflineUtil.getNodeValueFromNodeName( LOM_CORE_LESSON_LOCATION, mobjCmiElm );

		// <cmi>-<core>-<lesson_status>の値を取得する
		mstrLessonStatus = OfflineUtil.getNodeValueFromNodeName( LOM_CORE_LESSON_STATUS, mobjCmiElm );
		// <cmi>-<core>-<score>-<raw>の値を保持します。
		mstrRaw = OfflineUtil.getNodeValueFromNodeName( LOM_CORE_SCORE_RAW, mobjCmiElm );
		// <cmi>-<core>-<score>-<max>の値を保持します。
		mstrMax = OfflineUtil.getNodeValueFromNodeName( LOM_CORE_SCORE_MAX, mobjCmiElm );
		// <cmi>-<core>-<score>-<min>の値を保持します。
		mstrMin = OfflineUtil.getNodeValueFromNodeName( LOM_CORE_SCORE_MIN, mobjCmiElm );
		// <cmi>-<core>-<exit>の値を保持します。
		mstrExit = OfflineUtil.getNodeValueFromNodeName( LOM_CORE_EXIT, mobjCmiElm );
		// <cmi>-<comments>の値を保持します。
		mstrComments = OfflineUtil.getNodeValueFromNodeName( LOM_CORE_COMMENTS, mobjCmiElm );

		// <cmi>-<objectives>エレメントデータの設定
		NodeList objObjectivesList = mobjCmiElm.getElementsByTagName( LOM_OBJECTIVES );
		if( objObjectivesList.getLength() > 0 ) {
			mobjObjectives = new OfflineCmiObjectives( (Element)objObjectivesList.item(0) );
		}

	}
//------------------------------------ 内部関数 --------------------------------
}

